#!/bin/sh

if ! test "$#" = "3"
then
  echo "Usage: $0 <domain.tld> <input-file> <output-file>"
  exit 1
fi

ZNAME="$1"
INPUT="$2"
OUTPUT="$3"

if ! test -f "$INPUT"
then
  echo "Cannot find input file $INPUT"
  exit 1
fi

TEMPF="`mktemp test.XXXXXXXXXXX`"
ZTYPE="master"

#
# Main pgm, dump forward zone / no allow-transfers
#

echo "$ZNAME.|$ZTYPE {" >> ${TEMPF}
#if [ "$dump_allow_transfers" = "yes" ]
#then
#  ALLOWTRANSFERS="`echo $LINE|grep -Eo "allow-transfer[\t ]*{[^}]*}"|grep -Eo "[0-9]+\.[0-9]+\.[0-9]+\.[0-9]+[\t ]*;"|tr -s ';' ' '`"
#  ALLOWTRANSFER=""
#  for ALLOWTRANSFER in $ALLOWTRANSFERS
#  do
#    echo "|ALLOW_TRANSFER| |$ALLOWTRANSFER| || ||">>${TEMPF}
#  done
#fi
buff="`grep -Ev "^[ \t]*;" ${INPUT}|tr -s "\r" "\n"|sed 's/;.*//'|awk '
{
        if (toupper($4)=="TXT"){txt=substr($0,index($0,$5));gsub(/"/,"",txt); printf ("|%s| |%s| |%s| ||\n",toupper($4),$1,txt)};
        if (toupper($3)=="TXT"){txt=substr($0,index($0,$4));gsub(/"/,"",txt); printf ("|%s| |%s| |%s| ||\n",toupper($3),$1,txt)};
        if (toupper($1)=="TXT"){txt=substr($0,index($0,$2));gsub(/"/,"",txt); printf ("|%s| || |%s| ||\n",toupper($1),txt)};
        if ((NF==2)&&(toupper($1) ~ /ORIGIN/))  printf("|$ORIGIN| |%s| || ||\n", $2);
        if ((NF==4)&&(toupper($2)=="IN")&&(toupper($3)!="MX")&&(toupper($3)!="TXT")) printf("|%s| |%s| |%s| ||\n", toupper($3),$1,$4);
        if ((NF==5)&&(toupper($2)=="IN")&&(toupper($3)=="MX")&&(toupper($3)!="TXT")) printf("|%s| |%s| |%s| |%s|\n", toupper($3),$1,$5,$4);
        if ((NF==5)&&(toupper($3)=="IN")&&(toupper($4)!="MX")&&(toupper($4)!="TXT")) printf("|%s| |%s| |%s| ||\n", toupper($4),$1,$5);
        if ((NF==6)&&(toupper($3)=="IN")&&(toupper($4)=="MX")&&(toupper($4)!="TXT")) printf("|%s| |%s| |%s| |%s|\n", toupper($4),$1,$6,$5);
        if ((NF==3)&&(toupper($2)=="CNAME")&&(toupper($1)!="IN"))  printf("|%s| |%s| |%s| ||\n", toupper($2),$1,$3);
        if ((NF==3)&&(toupper($2)=="CNAME")&&(toupper($1)=="IN"))  printf("|%s| || |%s| ||\n", toupper($2),$3);
        if ((NF==2)&&(toupper($1)=="NS"))  printf("|%s| || |%s| ||\n", toupper($1),$2);
        if ((NF==2)&&(toupper($1)=="A"))  printf("|%s| || |%s| ||\n", toupper($1),$2);
        if ((NF==3)&&(toupper($2)=="A")&&(toupper($1)!="IN"))  printf("|%s| |%s| |%s| ||\n", toupper($2),$1,$3);
        if ((NF==2)&&(toupper($1)=="MX"))  printf("|%s| || |%s| |%s|\n", toupper($1),$2,$3);
        if ((NF==3)&&(toupper($1)=="MX"))  printf("|%s| || |%s| |%s|\n", toupper($1),$3,$2);
        if ((NF==3)&&(toupper($2)=="NS")&&(toupper($1)=="IN"))  printf("|%s| || |%s| ||\n", toupper($2),$3);
        if ((NF==3)&&(toupper($2)=="A")&&(toupper($1)=="IN"))  printf("|%s| || |%s| ||\n", toupper($2),$3);
        if ((NF==3)&&(toupper($2)=="MX")&&(toupper($1)=="IN"))  printf("|%s| || |%s| |%s|\n", toupper($2),$3,$4);
        if ((NF==4)&&(toupper($1)=="IN")&&(toupper($2)=="MX")) printf("|%s| || |%s| |%s|\n", toupper($2),$4,$3);
}
'`"
echo "${buff}" >> ${TEMPF}
echo "}" >> ${TEMPF}

mv $TEMPF $OUTPUT >>/dev/null 2>&1
echo "`grep -c "{" $OUTPUT` records processed sucesfully"

# eof
